#
# spec file for package libzrtpcpp (Version 1.3.0)
#
# Copyright (c) 2009 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#



Name:           libzrtpcpp
Summary:        A ccrtp extension for zrtp/Zfone support
BuildRequires:  gcc-c++ libccrtp-devel libgcc libgcrypt-devel pkgconfig
Version:        1.3.0
Release:        2
License:        GPL v3 or later
Group:          Development/Libraries/Other
Url:            http://www.gnu.org/software/commoncpp/commoncpp.html
Source0:        ftp://ftp.gnu.org/gnu/cccrtp/%{name}-%{version}.tar.bz2
Source1:        rpmlintrc
Patch1:         %name-1.0.1-compiler_warnings.patch
Patch2:         libzrtpcpp-1.3.0-missing_returns.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
This library is a GPL licensed extension to the GNU RTP Stack, ccrtp,
that offers compatibility with Phil Zimmermann's zrtp/Zfone voice
encryption, and which can be directly embedded into telephony
applications.



%package -n libzrtpcpp1
License:        GPL v2 or later ; LGPL v2.1 or later
Group:          Development/Libraries/Other
Summary:        A ccrtp extension for zrtp/Zfone support
Provides:       %{name} = %{version}
Obsoletes:      %{name} <= %{version}

%description -n libzrtpcpp1
This library is a GPL licensed extension to the GNU RTP Stack, ccrtp,
that offers compatibility with Phil Zimmermann's zrtp/Zfone voice
encryption, and which can be directly embedded into telephony
applications.



%package devel
License:        GPL v3 or later
Group:          Development/Libraries/Other
Summary:        Headers and static link library for libzrtpcpp
Requires:       libzrtpcpp1 = %{version} libccrtp-devel

%description devel
This package provides the header files, link libraries, and
documentation for building applications that use libzrtpcpp.



%prep
%setup -q
%patch1
%patch2

%build
%configure --disable-static --with-pic
%{__make} %{?jobs:-j%jobs}

%check
make check

%install
%makeinstall
rm -f %{buildroot}%{_libdir}/*.la

%clean
rm -rf %{buildroot}

%files -n libzrtpcpp1
%defattr(-,root,root,0755)
%doc AUTHORS COPYING README
%{_libdir}/*.so.*

%files devel
%defattr(-,root,root,0755)
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc
%{_includedir}/libzrtpcpp/*.h
%dir %{_includedir}/libzrtpcpp

%post -n libzrtpcpp1 -p /sbin/ldconfig

%postun -n libzrtpcpp1 -p /sbin/ldconfig

%changelog
